#!/usr/bin/env python

import os, sys, base64

VERSIONEER_b64 = """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"""
newver = "0.21"


def main():
    if len(sys.argv) < 2:
        print("Usage: versioneer install")
        sys.exit(1)

    command = sys.argv[1]
    if command in ("version", "--version"):
        print("versioneer (installer) %s" % newver)
        sys.exit(0)

    if command != "install":
        print("Usage: versioneer install")
        sys.exit(1)

    v = base64.b64decode(VERSIONEER_b64.encode('ASCII'))
    if os.path.exists("versioneer.py"):
        for line in open("versioneer.py").readlines()[:5]:
            if line.startswith("# Version: "):
                oldver = line[len("# Version: "):].strip()
                if oldver != newver:
                    print("replacing old versioneer.py (%s)" % oldver)
                break
        else:
            print("overwriting existing versioneer.py")
    with open("versioneer.py", "wb") as f:
        f.write(v)
    print("versioneer.py (%s) installed into local tree" % newver)
    print("Now running 'versioneer.py setup' to install the generated files..")
    if " " in sys.executable:
        import subprocess  # Do not import unless absolutely necessary to avoid compatibility issues
        subprocess.call([sys.executable, "versioneer.py", "setup"])
    else:
        os.execl(sys.executable, sys.executable, "versioneer.py", "setup")

if __name__ == '__main__':
    main()
